diff --git a/src/dec_macros.h b/src/dec_macros.h
index 27c0633888..2c1566ddde 100644
--- a/src/dec_macros.h
+++ b/src/dec_macros.h
@@ -503,11 +503,18 @@
 #define HANDLE_VECTOR(name, sizefield, code, dxf) \
   HANDLE_VECTOR_N(name, FIELD_VALUE(sizefield), code, dxf)
 
-//skip non-zero bytes and a terminating zero
+//count 1 bytes, until non-1 bytes or a terminating zero
 #define FIELD_NUM_INSERTS(num_inserts, type, dxf) \
       FIELD_VALUE(num_inserts)=0; vcount=0; \
       while ((vcount=(BITCODE_RC)bit_read_RC(dat))) \
         {\
+          if (vcount != 1) \
+            {\
+              LOG_ERROR("num_inserts [RC " FORMAT_RL "]: %d!\n", \
+                        FIELD_VALUE(num_inserts), (unsigned char)vcount) \
+              bit_advance_position(dat, -8); \
+              break;\
+            }\
           FIELD_VALUE(num_inserts)++;\
           LOG_INSANE("num_inserts [RC " FORMAT_RL "]: %d\n", \
                      FIELD_VALUE(num_inserts), (unsigned char)vcount)  \
diff --git a/src/encode.c b/src/encode.c
index d138da86f0..aab1d9e4fc 100644
--- a/src/encode.c
+++ b/src/encode.c
@@ -318,8 +318,12 @@ static bool env_var_checked_p;
       } \
   }
 
-#define FIELD_NUM_INSERTS(num_inserts, type, dxf)   \
-  FIELD_RL(num_inserts, dxf)
+#define FIELD_NUM_INSERTS(num_inserts, type, dxf) \
+  for (vcount=0; vcount<FIELD_VALUE(num_inserts); vcount++) \
+    {                       \
+      bit_write_RC(dat, 1); \
+    }                       \
+  bit_write_RC(dat, 0)
 
 #define HANDLE_VECTOR(name, sizefield, code, dxf) \
   HANDLE_VECTOR_N(name, FIELD_VALUE(sizefield), code, dxf)
